public class Aluno //Aluno deixa de ser classe abstrata
{

   private Comportamento comportamento; //ganha novo atributo comportamento
   private int conhecimento;
   private String nome;
   private RelaQueue relaq;
   
   public Aluno(String nm, RelaQueue rq)
   {
       comportamento = new Esforcado(this);
       nome = nm;
       relaq = rq;
   }
   
   public String getNome()
   {
       return nome;
   }
   
   public void fazEEntregaRelatorio()
   {
       float qualidade = (2*this.getDedicacao() + this.getInteligencia())/3;
       float originalidade = (this.getDedicacao() + 2*this.getInteligencia())/3;
       Relatorio rela = new Relatorio(qualidade, originalidade, this);
       relaq.queue(rela);
       conhecimento++;
   }
      
   public int getConhecimento() //retorna conhecimento
   {
       return conhecimento;
   }
   
   //agora, os métodos getInteligencia() e getDedicacao() são
   //delegados para o objeto comportamento do Aluno
   public float getInteligencia()
   {
       float inteligencia = comportamento.getInteligencia();
       
       return inteligencia;
   }
   
   public float getDedicacao()
   {
       float dedicacao = comportamento.getDedicacao();
       
       return dedicacao;
   }
   
   //será possível modificar o comportamento do aluno
   //o método lança exceção pois existirão subclasses que
   //lançarão exceções toda vez que se atribuir a um aluno 
   //um determinado comportamento "proibido" 
   public void setComportamento(Comportamento cmpto) throws Exception
   { 
       comportamento = cmpto;
   }

   public Comportamento getComportamento()
   {
       return comportamento;
   }
   
}
