

public class Teste extends junit.framework.TestCase
{
      public void testFuncionaComoOLab1() {
  //criando os objetos
  RelaQueue queue = new RelaQueue();
  Professor prof = new Professor(queue);
 
  // O que muda em termos de interface externa neste lab,
  // é a criação dos alunos. O que mostra que o nosso código
  // está bem desacoplado e a nossa refatoração não alterou
  // o funcionamento dos outros objetos (Professor, Relatório, etc).
    Aluno aluno1 = new Aluno("John Smith", queue);
    Aluno aluno2 = new Aluno("Mark Smith", queue);
    Aluno aluno3 = new Aluno("Joseph Smith", queue);
    Aluno aluno4 = new Aluno("Robert Smith", queue);
 try {
    aluno3.setComportamento( new SafoPreguicoso(aluno3) );
    aluno4.setComportamento( new SafoPreguicoso(aluno4) );
  } catch (Exception e) {
    fail("Não deveria lançar erro!");
  }
 
  //teste de alunoesforcado
  assertEquals(0.5, aluno1.getInteligencia(), 0.01);
  assertEquals(1, aluno1.getDedicacao(), 0.01);
 
  //teste de alunosafo
  assertEquals(1.0, aluno3.getInteligencia(), 0.01);
  assertTrue(aluno3.getDedicacao() != aluno3.getDedicacao()); //deve ser randomica
  assertTrue(aluno3.getDedicacao() < 0.5);
 
  //alunos comecam a fazer os relas
  aluno1.fazEEntregaRelatorio();
 
 //roubamos o relatório do primeiro aluno para investigá-lo
  Relatorio rela1 = queue.dequeue();
  assertEquals(aluno1, rela1.getAluno());
  assertTrue(rela1.getAluno().getNome().equals("John Smith"));
  assertTrue(rela1.getQualidade() < 0.9);
  assertTrue(rela1.getQualidade() > 0.8);
  assertTrue(rela1.getOriginalidade() < 0.7);
  assertTrue(rela1.getOriginalidade() > 0.6);
 
  //os outros continuam a fazer os relas
  aluno2.fazEEntregaRelatorio();
  aluno3.fazEEntregaRelatorio();
  aluno4.fazEEntregaRelatorio();
 
  //deve exibir a coreção dos relas dos aluno2, aluno3, e aluno4, nesta ordem
  //pois "roubamos" o relatório do aluno1
  prof.corrigirRelatorios();
}
 
public void testOsComportamentosFuncionamComoEspecificado() {
  RelaQueue queue = new RelaQueue();
  Aluno aluno1 = new Aluno("John", queue);
  Comportamento summa = new Summa(aluno1);
  Comportamento pemba = new Pemba(aluno1);
  Comportamento imprevisivel = new Imprevisivel(aluno1);
  Comportamento safo = new SafoPreguicoso(aluno1);
  Comportamento esforcado = new Esforcado(aluno1);
  Comportamento burro = new Burro(aluno1);
 
 //teste de esforcado
  assertEquals(0.5, esforcado.getInteligencia(), 0.01);
  assertEquals(1, esforcado.getDedicacao(), 0.01);
 
//teste de burro
  assertEquals(0.0, burro.getInteligencia(), 0.01);
  assertEquals(0.0, burro.getDedicacao(), 0.01);
 
//teste de summa
  assertEquals(1.0, summa.getInteligencia(), 0.01);
  assertEquals(1.0, summa.getDedicacao(), 0.01);
 
  //teste de safo
  assertEquals(1.0, safo.getInteligencia(), 0.01);
  assertTrue(safo.getDedicacao() != safo.getDedicacao()); //deve ser randomica
  assertTrue(safo.getDedicacao() < 0.5);
 
  //teste de imprevisivel
  assertTrue(imprevisivel.getInteligencia() != safo.getInteligencia()); //deve ser randomica
  assertTrue(imprevisivel.getInteligencia() < 1.0);
  assertTrue(imprevisivel.getDedicacao() != safo.getDedicacao()); //deve ser randomica
  assertTrue(imprevisivel.getDedicacao() < 1.0);
 
  //teste de pemba
  assertTrue(pemba.getInteligencia() != pemba.getInteligencia()); //deve ser randomica
  assertTrue(pemba.getInteligencia() < 0.5);
  assertTrue(pemba.getDedicacao() != pemba.getDedicacao()); //deve ser randomica
  assertTrue(pemba.getDedicacao() < 0.5);
 
}
 
public void testAsSubClassesDeAlunoTemRestricoes() {

    RelaQueue queue = new RelaQueue();
    
    AlunoITA alunoITA = new AlunoITA("John Smith", queue);
    AlunoUSP alunoUSP = new AlunoUSP("Mark Smith", queue);
    AlunoUnicamp alunoUnicamp = new AlunoUnicamp("Joseph Smith", queue);
 try {
    alunoITA.setComportamento( new SafoPreguicoso(alunoITA) );
    alunoITA.setComportamento( new Summa(alunoITA) );
    alunoUSP.setComportamento( new Burro(alunoUSP) );
    alunoUnicamp.setComportamento( new Burro(alunoUnicamp) ); 
  } catch (Exception e) {
    fail("Não deveria lançar erro!");
  }

 
 try {
    alunoITA.setComportamento( new Burro(alunoITA) );
    fail("Deveria lançar erro!");
  } catch (Exception e) {
     
    }
    
    
 try {
    alunoUSP.setComportamento( new SafoPreguicoso(alunoUSP) );
     fail("Deveria lançar erro!");
      } catch (Exception e) {
    
  }
 try {
    alunoUnicamp.setComportamento( new Summa(alunoUnicamp) );
    fail("Deveria lançar erro!");
     } 
     catch (Exception e) {
     
  }
}
 
public void testRelaQueueEhSubclasseDoGenericoQueue() {
  Queue<Relatorio> q = new RelaQueue(); //propriedade básica do polimorfismo
}


}
